//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <comobj.hpp>   // Notwendig
#include <math.hpp>

#include "msExcel.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormExcel *FormExcel;
//---------------------------------------------------------------------------
__fastcall TFormExcel::TFormExcel(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormExcel::BitBtnRunClick(TObject *Sender)
{
    // Excel starten
    MyEx = CreateOleObject( "Excel.Application" );
    // Excel sichtbar machen
    MyEx.OlePropertySet( "Visible" , true );

    // Zugriff auf die Workbooks
    MyWB = MyEx.OlePropertyGet( "Workbooks" );
    // Neues Workbook erstellen
    MyWB.OleFunction("Add");

    // Zugriff auf das erste Worksheet
    MyWS = MyWB.OlePropertyGet( "Item" , 1 );
    MyWB = MyWS.OlePropertyGet( "Worksheets" );
    // Dem Worksheet einen Namen geben
    MyWB.OlePropertyGet( "Item" , 1 ).OlePropertySet( "Name", "Daten" );

    // Zugriff auf das erste Worksheet
    MyWS = MyWB.OlePropertyGet( "Item" , 1 );

    // Werte in die Zellen eintragen
    // berschrift
    // Font nur fr Zelle einstellen
    MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", 1,1 ).
        OlePropertyGet("Font").OlePropertySet( "Bold" , true );
    MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", 1,1 ).
        OlePropertyGet("Font").OlePropertySet( "Color" , clGreen );        
    MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", 1,1 ).
        OlePropertySet( "Value" , "Datenerfassung" );

    // berschriften
    MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", 3,1 ).
        OlePropertyGet("Font").OlePropertySet( "Bold" , true );
    MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", 3,1 ).
        OlePropertySet( "Value" , "Datum" );
    MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", 3,2 ).
        OlePropertyGet("Font").OlePropertySet( "Bold" , true );
    MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", 3,2 ).
        OlePropertySet( "Value" , "Uhrzeit" );
    MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", 3,3 ).
        OlePropertyGet("Font").OlePropertySet( "Bold" , true );
    MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", 3,3 ).
        OlePropertySet( "Value" , "Messwert" );

    // Werte eintragen
    TDateTime DateAndTime;
    Randomize();

    for( int i = 5; i < 15; i++ )
    {
        Sleep(500);
        DateAndTime.CurrentDateTime();
        // Datum eintragen
        MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", i,1 ).
            OlePropertySet( "Value" , DateAndTime.CurrentDate() );
        // Uhrzeit eintragen
        MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", i,2 ).
            OlePropertySet( "Value" , DateAndTime.CurrentTime() );
        // Messwert
        MyWS.OlePropertyGet( "Cells" ).OlePropertyGet( "Item", i,3 ).
            OlePropertySet( "Value" , RandomRange(0,100) );
     } // for i

}
//---------------------------------------------------------------------------
void __fastcall TFormExcel::BitBtn1Click(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormExcel::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    // Kontrollieren, ob eine Excel Anwemdung luft.
    if( !MyEx.IsEmpty() )
    {
        MyEx.OlePropertySet( "DisplayAlerts", false );
        MyEx.OlePropertyGet("Workbooks").OlePropertyGet( "Item" , 1).
            OleProcedure("SaveAs" , "value.xls");
        MyEx.OleFunction( "Quit" );
    }
}
//---------------------------------------------------------------------------
